import { SELECT_MOVE_INVOICE, SELECT_MOVE } from '@/constants/actionTypes'
import { SET_MOVES, SET_SELECTED_MOVE_LINE, SET_SELECTED_MOVE_PAYMENTS } from '@/constants/mutationTypes'

const initialState = {
    moves : null,
    selectedMoveLine: null,
    movesPayments: []
}

const state = {
    moves: initialState.moves,
    selectedMoveLine: initialState.selectedMoveLine,
    movesPayments: initialState.movesPayments
}

const getters = {
    /**
     * [moves description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    moves(state) {
        return state.moves
    },
    /**
     * [selectedMoveLine description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    selectedMoveLine(state){
        return state.selectedMoveLine
    },
    /**
     * [movesPayments description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    movesPayments(state) {
        return state.movesPayments
    }
}

const mutations = {
    /**
     * [moves description]
     * @type {[type]}
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_MOVES] (state, payload) {
        state.moves =  payload
    },
    /**
     * [selectedMoveLine description]
     * @type {[type]}
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_SELECTED_MOVE_LINE] (state, payload) {
        state.selectedMoveLine = payload
    },
    /**
     * [movesPayments description]
     * @type {[type]}
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_SELECTED_MOVE_PAYMENTS] (state, payload) {
        state.movesPayments = [payload, ...state.movesPayments]
    }
}

const actions = {
    /**
     * [SELECT_MOVE_INVOICE]
     * @param {*} param0
     * @param {*} payload
     */
    [SELECT_MOVE_INVOICE] ({ commit }, payload) {
        commit(SET_MOVES, payload)
    },
    /**
     * [SELECT_MOVE]
     * @param {*} param0
     * @param {*} payload
     */
    [SELECT_MOVE] ({ commit }, payload) {
        commit(SET_SELECTED_MOVE_PAYMENTS, payload)
        commit(SET_SELECTED_MOVE_LINE, payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
